#define GLOBAL
GLOBAL double Rpoul = 0.0125;							/* Rayon poulie */
GLOBAL int flagbas[9] = {0, 1, 1, 0, 0, 1, 1, 0, 0};	/* 1 pour poulies basses */
GLOBAL double OA_ref[3*4] = {-1., 0., 0.,                    
					    1.,0.,0.,0., 1.,0.,0.,0.,1.};               

/* Position des points d'attache */
GLOBAL double ABi[3*9] = 
{
	-0.523,  0.000, -0.001,  /* 0 : point central arrire */
	 0.000,  0.000,	 0.041,  /* 1 : ventral tribord */ 
     0.000,  0.000,  0.041,  /* 2 : ventral babord */
    -0.523,  0.008, -0.005,  /* 3 : AR tribord */
    -0.523, -0.008, -0.005,  /* 4 : AR babord */
     0.000,  0.000, -0.047,  /* 5 : dorsal tribord */
     0.000,  0.000, -0.047,  /* 6 : dorsal babord */
    -0.443,  0.080, -0.003,  /* 7 : roulis tribord */
    -0.443, -0.080, -0.003   /* 8 : roulis babord */
};

/* Points droits des poulies */
GLOBAL double OHi[3*9] = 
{
 -3.1115000, -0.0000000,  2.8511000, /* 0 : poteau haut ventral */
 -0.1345000,  2.0160321,  2.0160321, /* 1 : poteau bas ventral tribord */
 -0.1345000, -2.0160321,  2.0160321, /* 2 : poteau bas ventral babord */
 -3.1115000,  2.7539511,  0.7379190, /* 3 : poteau haut AR tribord */
 -3.1115000, -2.7539511,  0.7379190, /* 4 : poteau haut AR babord */
 -0.1345000,  2.0160321, -2.0160321, /* 5 : poteau bas dorsal tribord */
 -0.1345000, -2.0160321, -2.0160321, /* 6 : poteau bas dorsal babord */
 -3.1115000,  0.0210925, -2.8510220, /* 7 : poteau haut roulis tribord */
 -3.1115000, -0.0210925, -2.8510220  /* 8 : poteau haut roulis babord */
};

/* Position acclromtres */
GLOBAL double APi[3*7] = 
{
	 0.010,  0.200,  0.,
	 0.010, -0.200,  0.,
	 0.350,  0.001,  0.,
	-0.330, -0.002,  0.,
	 0.300,  0.,    -0.001,
	-0.280,  0.,     0.002,
	-0.100,  0.001, -0.001 
};

/* Directions axes acclromtres */
GLOBAL double uAi[3*7] = 
{
	0.,0.,1.,
	0.,0.,1.,
	0.,0.,1.,
	0.,0.,1.,
	0.,1.,0.,
	0.,1.,0.,
	1.,0.,0.
};
