#include <math.h>
#include "utils.h"
/*
 Distance minimale entre deux segments de droite AB et CD 
 dfinis par les points A, B, C, D 
*/
double dmin2segs(double *A, double *B, double *C, double *D)
{
double BA[3], CD[3], AC[3];
double x,y,a,b,c,d,e,f, delta;
double aa, bb, cc;

	subv3(BA,A,B);
	subv3(CD,D,C);
	subv3(AC,C,A);
/*
% On commence par rsoudre 
%    a x + c y + d = 0
%    c x + b y + e = 0
% Avec :
*/
	a = dotv3(BA,BA);
	b = dotv3(CD,CD);
	c = dotv3(BA,CD);
	d = dotv3(BA,AC);
	e = dotv3(AC,CD);
	f = dotv3(AC,AC);
	delta = a*b-c*c;
	if (delta != 0.)
	{
		x = (c*e-b*d)/delta;
		if (x >= 0. && x <= 1.)
		{
			y = (c*d-a*e)/delta;
			if (y >= 0. && y <= 1.) return sqrt(f + d*x + e*y); 
			if (y > 1.)
			{ y = 1. ; aa = a; bb = c+d ; cc = f+b+e+e; }/* ???? Pas sur ???? */
			else {y = 0. ; aa = a; bb = d ;   cc = f; }  /* ???? Pas sur ???? */  
			if (aa != 0.) x = -bb/aa ; else x = 0.;
			if (x >= 0.)
			{
				if (x <= 1.)return sqrt(cc+bb*x);
				x = 1.; aa = b; bb = c+e; cc = f + a + d+d;
				if (aa != 0.) y = -bb/aa ; else y = 0.;
				if (y >= 0.)
				{/* Cas impossible */
					if (y <= 1.) return sqrt(cc+bb*y);
					return sqrt(a+b+f+2.*(c+d+e)); 
				}
				return sqrt(a+d+d+f);
			}
			x = 0.; aa = b; bb = e; cc = f;
			if (aa != 0) y = -bb/aa ; else y = 0.;
			if (y >= 0.)
			{/* Cas impossible */
				if (y <= 1.) return sqrt(cc+bb*y);
				return sqrt(b+e+e+f); 
			}
			return sqrt(f);
		}
		else
		{
			if (x > 1) 
			{x = 1. ; aa = b; bb = c+e; cc = f + a + d+d; } /* ???? Pas sur ???? */
			else {x = 0. ; aa = b; bb = e;   cc = f; } /* ???? Pas sur ???? */
			if (aa != 0) y = -bb/aa ; else y = 0.; 
			if (y >= 0.)
			{
				if (y <= 1.) return sqrt(cc+bb*y);
				y = 1. ; aa = a; bb = c+d ; cc = f+b+e+e;
				if (aa != 0.) x = -bb/aa ; else x = 0.; 
				if (x >= 0.)
				{
					if (x <= 1.) return sqrt(cc+bb*x);
					return sqrt(a+b+f+2.*(c+d+e));
				}
				return sqrt(b+e+e+f);
			}
			y = 0. ; aa = a; bb = d ; cc = f;
			if (aa != 0.) x = -bb/aa ; else x = 0.;
			if (x >= 0.)
			{
				if (x <= 1.) return sqrt(cc+bb*x);
				return sqrt(a+d+d+f);
			}
			return sqrt(f); 
		}
	}
	else /* delta < 0 */
	{
	double AB2, ABAC, AC2, ABAD, bid[3];
		x = 0 ; y = 0;
		AB2 = a; ABAC = -d; AC2 = f;
		/* Test si C entre A et B */
		ABAD = dotv3(BA,subv3(bid,D,A));
		if ((ABAC >= 0. && ABAC <= AB2) || (ABAD >= 0 && ABAD <= AB2))
			return sqrt(AC2-ABAC*ABAC/AB2);
		/* Test si C et D de part et d'autre de A et B */
		if ((ABAC < 0. && ABAD > AB2) || (ABAD < 0 && ABAC > AB2))
			return sqrt(AC2-ABAC*ABAC/AB2);
		if (ABAC < 0.)
		{
			if (ABAD < ABAC) return sqrt(AC2);
			else return sqrt(b+e+e+f); /* AD2 (x=0, y=1) */
		}
		else
		{
			if (ABAD > ABAC) return sqrt(a+d+d+f); /* BC2 (x=1, y=0) */
			else return sqrt(a+b+f+2.*(c+d+e)) ; /* BD2 (x=1, y=1) */
		}  
	}
}
   
   
