#include <windows.h>
/*----------------------------------------------------------------------------*\
|    getNomOpenFich()                                                           |
|                                                                               |
|    Appelle la bote de commdlg pour obtenir le nom du fichier  ouvrir        |
|        szNomfich  : nom fichier obtenu                                        |
|        szTitreDlg : titre  affecter  la bote de dialogue                   |
|        szFilterDlg: chanes de filtrage des noms de fichier style *.txt ..    |
|    Renvoi TRUE si un nom de fichier valide a t obtenu                       |
\*----------------------------------------------------------------------------*/
int getNomOpenFich(HWND hwnd, char *szNomfich, char *szTitreDlg, 
					char *szFilterDlg)
{
	char buffich[MAX_PATH] ;
	BOOL ok ;
    OPENFILENAME ofn;

    buffich[0] = 0;

    ofn.lStructSize			= sizeof(OPENFILENAME);
    ofn.hwndOwner			= hwnd;
    ofn.hInstance			= NULL;
    ofn.lpstrTitle			= szTitreDlg;
    ofn.lpstrFilter			= szFilterDlg;
    ofn.lpstrCustomFilter	= NULL;
    ofn.nMaxCustFilter		= 0;
    ofn.nFilterIndex		= 0;
    ofn.lpstrFile			= buffich;
    ofn.nMaxFile			= sizeof(buffich) ;
    ofn.lpstrFileTitle		= NULL;
    ofn.nMaxFileTitle		= 0;
    ofn.lpstrInitialDir		= NULL;
    ofn.Flags				= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
    ofn.nFileOffset			= 0;
    ofn.nFileExtension		= 0;
    ofn.lpstrDefExt			= NULL;
    ofn.lCustData			= 0;
    ofn.lpfnHook			= NULL;
    ofn.lpTemplateName		= NULL;

    ok = GetOpenFileName(&ofn) ;
	if (ok) strcpy (szNomfich, buffich) ;
	return ok ;
}
